# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ...model import implements, Model
from ...plugins import IPlugin, IPluginManager
from ...ui import IDisplay


@implements(IPlugin, IDisplay)
class IBuilderProjectToolPlugin(Model):
    """ The IBuilderProjectToolPlugin class is the plugin definition for a tool
    for editing models that implement the IBuilderProject interface.
    """

    # The identifier of the plugin.
    id = 'dip.builder.tools.project_editor'

    # The name of the plugin.
    name = "DIP builder project editor plugin"

    def configure(self, plugin_manager):
        """ Configure the plugin. """

        # Create the tool instance.
        from ..builder_project_tool import IBuilderProjectTool
        tool = IBuilderProjectTool()

        # Contribute the tool.
        IPluginManager(plugin_manager).contribute('dip.shell.tools', tool)
