# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ...shell import SimpleViewTool


class PluginsViewerTool(SimpleViewTool):
    """ The PluginsViewerTool implements a tool for displaying plugins. """

    # The identifier to be used for any action.
    action_id = 'dip.developer.view_plugins'

    # The tool's name.
    name = "Plugins"

    # The optional identifier of a collection of actions that any action will
    # be placed within.
    within = 'dip.ui.collections.view'

    @SimpleViewTool.view.default
    def view(self):
        """ The default view implementation. """

        from .plugins_viewer import PluginsViewer

        return PluginsViewer()
