# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ....model import implements, Model

from ... import IStreamingStorageFactory


@implements(IStreamingStorageFactory)
class FilesystemStorageFactory(Model):
    """ The FilesystemStorageFactory class is a factory for
    :term:`streaming storage` based on a local filesystem.
    """

    def __call__(self, codec):
        """ Create a storage instance.

        :param codec:
            is the codec to be used by the storage.
        :return:
            the storage instance.
        """

        from .filesystem_storage import FilesystemStorage

        return FilesystemStorage(codec=codec)
