# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QWidget

from ....model import adapt, Adapter
from ....shell import IDirty
from ....ui import IView

from ..widget_adapter import WidgetAdapter


@adapt(QWidget, to=IView)
class QWidgetIViewAdapter(WidgetAdapter):
    """ An adapter to implement IView for any widget. """


@adapt(QWidget, to=IDirty)
class QWidgetIDirtyAdapter(Adapter):
    """ An adapter to implement IDirty for any widget. """

    @IDirty.dirty.getter
    def dirty(self):
        """ Invoked to get the dirty state. """

        return self.adaptee.isWindowModified()

    @dirty.setter
    def dirty(self, value):
        """ Invoked to set the dirty state. """

        self.adaptee.setWindowModified(value)
