# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from .i_editor import IEditor


class ICollectionEditor(IEditor):
    """ The ICollectionEditor interface defines the API to be implemented
    (typically using adaptation) by an editor that handles a collection type
    (e.g. a list).
    """

    def item_invalid_reason(self, invalid_reason):
        """ Update the invalid reason for the current item in the collection.

        :param index:
            is the invalid reason.  It will be an empty string if the item is
            valid.
        """
