import sys

from PyQt4.QtGui import QApplication, QHBoxLayout, QWidget

from dip.model import Int, Model, Str
from dip.ui import Form, SpinBox


# Define the model.
class ExampleModel(Model):

    # The name.
    name = Str(tool_tip="The person's full name")
    
    # The age in years.
    age = Int(minimum=0, maximum=120)


# Every PyQt GUI application needs a QApplication.
app = QApplication(sys.argv)

# Create the model.
model = ExampleModel()

# Define the view.
view = Form('name', SpinBox('age', suffix=" years"))

# Create two instances of the view bound to the same model.
ui_left = view(model)
ui_right = view(model)

# Create a regular PyQt widget showing the two views side by side.
layout = QHBoxLayout()
layout.addWidget(ui_left)
layout.addWidget(ui_right)

ui = QWidget(windowTitle="Real Model")
ui.setLayout(layout)
ui.show()

# Enter the event loop.
app.exec_()

# Show the value of the model.
print("Name:", model.name)
print("Age:", model.age)
